/*
   ADR Levels
*/
#property copyright "Copyright  2010, BumaSoft, LTD"
#property link      "http://www.bumasoft.com"

#property indicator_chart_window

extern int ADR_Period = 5;
extern int shift = 0;

int init() {
   return (0);
}

void PlotLevel(string A_name_0, double A_price_8, color A_color_16, string A_text_20, int A_fontsize_28) {
   ObjectDelete(A_name_0);
   ObjectDelete(A_name_0 + "_desc");
   ObjectCreate(A_name_0, OBJ_TREND, 0, iTime(NULL, PERIOD_D1, 0), A_price_8, iTime(NULL, 0, 0), A_price_8);
   ObjectSet(A_name_0, OBJPROP_WIDTH, 1);
   ObjectSet(A_name_0, OBJPROP_STYLE, STYLE_DASHDOT);
   ObjectSet(A_name_0, OBJPROP_RAY, TRUE);
   ObjectSet(A_name_0, OBJPROP_BACK, TRUE);
   ObjectSet(A_name_0, OBJPROP_COLOR, A_color_16);
   ObjectCreate(A_name_0 + "_desc", OBJ_TEXT, 0, Time[0], A_price_8);
   ObjectSetText(A_name_0 + "_desc", A_text_20, A_fontsize_28, "Verdana", A_color_16);
}

void displayADR() {
   double Ld_0 = 0;
   double Ld_8 = 0;
   double Ld_16 = 0;
   double Ld_24 = 0;
   double Ld_32 = 0;
   double Ld_40 = 0;
   double Ld_48 = 0;
   for (int Li_56 = shift + 1; Li_56 <= ADR_Period + shift; Li_56++) Ld_0 += iHigh(NULL, PERIOD_D1, Li_56) - iLow(NULL, PERIOD_D1, Li_56);
   Ld_0 /= ADR_Period;
   if (Bid < iOpen(NULL, PERIOD_D1, shift)) {
      Ld_8 = iHigh(NULL, PERIOD_D1, shift);
      Ld_16 = Ld_8 - Ld_0;
   } else {
      Ld_16 = iLow(NULL, PERIOD_D1, shift);
      Ld_8 = Ld_16 + Ld_0;
   }
   Ld_24 = Ld_16 - Ld_0 / 2.0;
   Ld_40 = Ld_8 + Ld_0 / 2.0;
   Ld_32 = Ld_16 - Ld_0;
   Ld_48 = Ld_8 + Ld_0;
   PlotLevel("adr_high", Ld_8, Red, "ADR High - " + DoubleToStr(Ld_8, Digits), 8);
   PlotLevel("adr_low", Ld_16, Lime, "ADR Low - " + DoubleToStr(Ld_16, Digits), 8);
   PlotLevel("adr_high_ext1", Ld_40, Red, "ADR High Extension 1 - " + DoubleToStr(Ld_40, Digits), 8);
   PlotLevel("adr_low_ext1", Ld_24, Lime, "ADR Low Extension 1 - " + DoubleToStr(Ld_24, Digits), 8);
   PlotLevel("adr_high_ext2", Ld_48, Red, "ADR High Extension 2 - " + DoubleToStr(Ld_48, Digits), 8);
   PlotLevel("adr_low_ext2", Ld_32, Lime, "ADR Low Extension 2 - " + DoubleToStr(Ld_32, Digits), 8);
}

int start() {
   displayADR();
   return (0);
}
